// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the Peter Jodda license:
// Everyboy may use it on his own risk. This header must stay in the file!
// If you expand this file, please contact me, that I can integrate the
// enhancemants in the original file.
//

#include <qdialog.h>
#include <qpushbutton.h>
#include <qgrid.h>
#include <qlayout.h>
#include <qlabel.h>


#include <stdio.h>

#include "AboutBox.h"
#include "IconLibrary.h"
#include "ApplicationFrame.h"


//-----------------------------------------------------------------------------

AboutBox::AboutBox(QWidget *parent) : 
                          QDialog(parent,"About",TRUE)
{
   PixelBuffer *PericoBuffer;
   QPushButton *ok;
   QGridLayout *grid;
   QBoxLayout  *topLayout;
   QPalette    pal;
   QPixmap     *Perico;
   QLabel      *m_PericoImageLabel;
   QColor      aColor;
   char        versionString[20];
   char        buildString[30];

   // load perico image to get its background pixel
   PericoBuffer = g_Application->m_pc_IconLibrary->GetIcon("Perico");
   if(PericoBuffer != NULL)
   {
      // get background
      aColor = PericoBuffer->Get(0,0);
      // buffer is not needed anymore
      delete PericoBuffer;
      // set background of widget to the image background
      pal.setColor( QColorGroup::Background, aColor );
      pal.setColor( QColorGroup::Button, aColor );
   
      setPalette( pal );
   }
   
   setCaption("About Perico");

   Perico = g_Application->m_pc_IconLibrary->GetPixmap("Perico");

   topLayout = new QVBoxLayout( this, 2 );

   topLayout->addWidget(new QLabel(" ",this));
   topLayout->addWidget(new QLabel("Perico",this),0,AlignHCenter);
   topLayout->addWidget(new QLabel(" ",this));
   m_PericoImageLabel = new QLabel(" ",this);
   m_PericoImageLabel->setPixmap(*Perico);

   topLayout->addWidget(m_PericoImageLabel,0,AlignHCenter);
   topLayout->addWidget(new QLabel(" ",this));


   sprintf(versionString,"%10s",PERICO_VERSION);
   sprintf(buildString  ,"%s",   __DATE__ );

   grid = new QGridLayout( topLayout, 2, 2,10);
   grid->addWidget(new QLabel("Version",this),0,0);
   grid->addWidget(new QLabel("Build on",this),1,0);
   grid->addWidget(new QLabel(versionString,this),0,1);
   grid->addWidget(new QLabel(buildString,this),1,1);


   topLayout->addWidget(new QLabel(" ",this));
   topLayout->addWidget(new QLabel("Peter Jodda / peter AT jodda.de",this) ,0,AlignRight);
   topLayout->addWidget(new QLabel(" ",this));


   // --- the ok button
   ok = new QPushButton( "OK", this );
   connect( ok, 
            SIGNAL(clicked()), 
            SLOT(accept()) );

   topLayout->addWidget(ok,20,AlignCenter);
   delete Perico;


} // Aboutbox constructor

