
#include <stdlib.h>

#include "IconLibrary.h"
#include "QtUtilities.h"
#include "ApplicationFrame.h"

extern unsigned char IconLibraryMemoryData[];

//===========================================================================
//
//===========================================================================
ApplicationStorage *g_Application;

ApplicationFrame::ApplicationFrame(QApplication *pc_Application)
{
   m_i_NumberOfImages = 0;


   m_pc_ApplicationStorage = new ApplicationStorage;
   m_pc_ApplicationStorage->m_pc_IconLibrary = new IconLibrary(IconLibraryMemoryData);
   m_pc_ApplicationStorage->m_pc_QtUtility = new QtUtility();
   m_pc_ApplicationStorage->m_pc_ApplicationFrame = this;

   g_Application = m_pc_ApplicationStorage;

} // ApplicationFrame() - constructor

//===========================================================================
//
//===========================================================================

ApplicationFrame::~ApplicationFrame()
{
   delete m_pc_ApplicationStorage->m_pc_IconLibrary;
   delete m_pc_ApplicationStorage->m_pc_QtUtility;
   delete m_pc_ApplicationStorage;
} // ~ApplicationFrame()

//===========================================================================
//
//===========================================================================

void ApplicationFrame::AddMainFrame(MainFrame *pc_NewFrame)
{
   m_Images.append(pc_NewFrame);
   m_i_NumberOfImages +=1;
} // AddMainFrame()

//===========================================================================
//
//===========================================================================

void ApplicationFrame::RemoveMainFrame(MainFrame *pc_OldFrame)
{
   int i;
   for(i=0; i< m_i_NumberOfImages; i++)
   {
      if(m_Images.at(i) == pc_OldFrame)
      {
         m_Images.remove(i);
         m_i_NumberOfImages -= 1;
         break;
      }
   }
   if(m_i_NumberOfImages ==0)
   {
      Terminate();
   }
} // RemoveMainFrame()

//===========================================================================
//
//===========================================================================

void ApplicationFrame::Terminate()
{
   // later: save some settings

   exit(0);
} // Terminate()

//===========================================================================
//
//===========================================================================

void ApplicationFrame::ExitCall(MainFrame *pc_CallingFrame)
{
   while (m_i_NumberOfImages >0)
   {
      // delete the image
      delete m_Images.at(m_i_NumberOfImages -1);
      // remove it from the list
      m_Images.remove(m_i_NumberOfImages -1);

      m_i_NumberOfImages -= 1;

   } // while images there

   // terminate program
   Terminate();
} // ExitCall()

//===========================================================================
//
//===========================================================================

