#ifndef _BUFFERFILL_H
#define _BUFFERFILL_H

#include "PTypes.h"
#include "PixelBuffer.h"
#include "RectRegion.h"

class BufferFillPoint
{
public:
   int m_i_X;
   int m_i_Y;
};

#define NUMBER_OF_CONTINUE_POINTS_MAX 5000

class BufferFill
{
public:
   BufferFill();

   enum
   {
      BufferFillDistanceOrigin=0,
      BufferFillDistanceColor
   };

   void StartFill(int i_StartX, int StartY);

   void SetColorDistance(int i_Distance);
   void SetColorDistanceColor(Pixel p);
   void SetColorDistanceFrom(int i_DistanceMode);

   // source, where to look
   PixelBuffer * m_pc_SourceBuffer;

   // destination. Where to put in the result
   // if null, then use also the source to fill direct
   PixelBuffer * m_pc_DestinationBuffer;

   Pixel m_NewColor;
   Pixel m_ChangeColor;

   RectRegion GetChangedRegion();


private:
   BufferFillPoint m_ContinuePoints[NUMBER_OF_CONTINUE_POINTS_MAX];
   int m_i_NumberOfContinuePoints;


   void Push(int i_X, int i_Y);
   bool Pop(int &i_X, int &i_Y);
   bool HasToFill(int i_X, int i_Y);
   void FillPoint(int i_X, int i_Y);

   int m_i_SourceHeight;
   int m_i_SourceWidth;


   int m_i_MinX;
   int m_i_MinY;
   int m_i_MaxX;
   int m_i_MaxY;
   int m_i_FilledPoint;

   int m_i_MaxStack;
   Pixel m_p_RealUsedDistanceColor;


   int   m_i_Distance;
   Pixel m_p_DistanceColor;
   int   m_i_DistanceMode;


}; // BufferFill

#endif //  _BUFFERFILL_H

