#include "BufferPainterEdges.h"

#include <stdio.h>

//===========================================================================
//
//===========================================================================

BufferPainterEdgesLine::BufferPainterEdgesLine()
{
   // initialize the structure
   m_i_PointListSize = 11;
   m_i_PointCount    = 0;
   m_pi_PointList    = new int[m_i_PointListSize];
   if(m_pi_PointList == NULL)
   {
      m_i_PointListSize =0;
   }

} // BufferPainterEdgesLine()

//===========================================================================
//
//===========================================================================

BufferPainterEdgesLine::~BufferPainterEdgesLine()
{
   if(m_pi_PointList != NULL)
   {
      delete[] m_pi_PointList;
      m_pi_PointList = NULL;
   }
} // ~BufferPainterEdgesLine()


//===========================================================================
//
//===========================================================================


void BufferPainterEdgesLine::AddPoint(int i_Point)
{
   int i;
   int i_Current;

   // pointlist must no be empty
   if(m_pi_PointList == NULL)
   {
      return;
   }

   // if there is not enogh space
   if((m_i_PointCount + 1) >= m_i_PointListSize)
   {
      // increase the list
      int * pi_NewList;
      pi_NewList = new int[2*m_i_PointListSize];
      if(pi_NewList == NULL)
      {
         return ;
      }
      // copy the current elements
      for(i=0;i<m_i_PointCount;i++)
      {
         pi_NewList[i] = m_pi_PointList[i];
      }
      delete[] m_pi_PointList;
      m_pi_PointList = pi_NewList;
      m_i_PointListSize *= 2;
   }

   // now insert the new point
   i_Current = -1;
   for(i=0;i<m_i_PointCount ; i++)
   {
      if(i_Point ==m_pi_PointList[i])
      {
         // delete the current point
         int j;
         for(j=i; j <m_i_PointCount -1; j++)
         {
            m_pi_PointList[j] = m_pi_PointList[j+1];
         }
         m_i_PointCount --;
         return;
      }

      if(i_Point > m_pi_PointList[i])
      {
         int j;
         // insert before
         i_Current = i;
         // move elements one position back
         for(j=m_i_PointCount+1; j>i ; j--)
         {
            m_pi_PointList[j] = m_pi_PointList[j-1];

         }
         m_i_PointCount ++;
         m_pi_PointList[i]= i_Point;
         return;
      }
   }
   // new point at the end;
   m_pi_PointList[m_i_PointCount]= i_Point;
   m_i_PointCount ++;


} // AddPoint()

//===========================================================================
//
//===========================================================================

int BufferPainterEdgesLine::GetNumber()
{
   return m_i_PointCount;
} // GetNumber()

//===========================================================================
//
//===========================================================================

int BufferPainterEdgesLine::GetPoint(int i_Index)
{
   if(   i_Index <0
      || i_Index >= m_i_PointCount
      || m_pi_PointList == NULL)
   {
      return 0;
   }

   return m_pi_PointList[i_Index];
} // GetPoint()

//===========================================================================
//
//===========================================================================

BufferPainterEdges::BufferPainterEdges(int i_StartLine, int i_EndLine)
{
   int i_Size;

   m_i_StartLine = i_StartLine;
   m_i_EndLine   = i_EndLine;

   i_Size = (m_i_EndLine - m_i_StartLine) + 1;
   if(i_Size <=0)
   {
      m_pc_Lines = NULL;
      return ;
   }
   m_pc_Lines = new BufferPainterEdgesLine[i_Size];

} // BufferPainterEdges()

//===========================================================================
//
//===========================================================================

BufferPainterEdges::~BufferPainterEdges()
{
   if(m_pc_Lines != NULL)
   {
      delete[] m_pc_Lines;
      m_pc_Lines = NULL;
   }
} // ~BufferPainterEdges()

//===========================================================================
//
//===========================================================================

void BufferPainterEdges::AddLinePoint(int i_X, int i_Y)
{  
   if(   i_Y < m_i_StartLine
      || i_Y > m_i_EndLine)
   {
      return;
   }
   i_Y -= m_i_StartLine;
   m_pc_Lines[i_Y].AddPoint(i_X);

} // AddLinePoint()
//===========================================================================
//
//===========================================================================

int BufferPainterEdges::GetStartLine()
{
   return m_i_StartLine;
} // GetStartLine()

//===========================================================================
//
//===========================================================================

int BufferPainterEdges::GetEndLine()
{
   return m_i_EndLine;
} // GetEndLine()

//===========================================================================
//
//===========================================================================

BufferPainterEdgesLine * BufferPainterEdges::GetLine(int i_LineIndex)
{
   if(   i_LineIndex < m_i_StartLine
      || i_LineIndex > m_i_EndLine)
   {
      return NULL;
   }
   i_LineIndex -= m_i_StartLine;
   
   return &(m_pc_Lines[i_LineIndex]);

} // GetLine()

//===========================================================================
//
//===========================================================================
