
#include "stddef.h"

#include "Callback.h"

//===========================================================================
//
//===========================================================================

Callback::Callback()
{

     m_pf_CallbackFunction = NULL;
     m_pc_ThisData         = NULL;

}

//===========================================================================
//
//===========================================================================

Callback::Callback(CallbackFunction pf_Callback, void *ThisData)
{

   m_pf_CallbackFunction = pf_Callback;
   m_pc_ThisData         = ThisData;

}

//===========================================================================
//
//===========================================================================

Callback::~Callback()
{
}

//===========================================================================
//
//===========================================================================

void * Callback::Execute(void * pc_ClientData)
{
   if( m_pf_CallbackFunction ==NULL)
   {
      return NULL;
   }

   return m_pf_CallbackFunction(m_pc_ThisData,pc_ClientData);


} // Execute()

//===========================================================================
//
//===========================================================================

void Callback::Clear()
{

   m_pf_CallbackFunction = NULL;
   m_pc_ThisData         = NULL;

}

//===========================================================================
//
//===========================================================================

bool Callback::IsEmpty()
{
   if( m_pf_CallbackFunction ==NULL)
   {
      return true;
   }

   return false;

} // IsEmpty()

//===========================================================================
//
//===========================================================================

bool Callback::operator==(Callback c_Other)
{
   if(     m_pf_CallbackFunction == c_Other.m_pf_CallbackFunction
       &&  m_pc_ThisData == c_Other.m_pc_ThisData)
   {
      return true;
   }

   return false;
} // operator==

//===========================================================================
//
//===========================================================================



