#ifndef _CORRECTIONBOX_H
#define _CORRECTIONBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qvgroupbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

#include "StandardDialog.h"
#include "QUCorrectionCurve.h"

class CorrectionBox :  public StandardDialog ,
                  public Tracer
{
Q_OBJECT


public:
   CorrectionBox(QWidget *parent=0,
            GlobalStorage *pc_Global=0);
   ~CorrectionBox();


public slots:
   void	LightnessCurveChanged(unsigned char *uc_CorrectionCurve);
   void	RedCurveChanged(unsigned char *uc_CorrectionCurve);
   void	GreenCurveChanged(unsigned char *uc_CorrectionCurve);
   void	BlueCurveChanged(unsigned char *uc_CorrectionCurve);
   void ApplyPressed();
   void VisibleChecked(bool b_On);
   
   void ModeChanged(int i_NewMode);

private:


    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);

   void SetSensitivity();
   void Disable();

private: // variables
   QButtonGroup     * m_ModeWidget;
   QRadioButton    * m_ModeLightnessButton;
   QRadioButton    * m_ModeColorButton;


   QVGroupBox   *m_LightnessBox;
   QVGroupBox   *m_ColorBox;

   QUCorrectionCurve *m_pc_LighnessCorrection;
   QUCorrectionCurve *m_pc_RedCorrection;
   QUCorrectionCurve *m_pc_GreenCorrection;
   QUCorrectionCurve *m_pc_BlueCorrection;
   QCheckBox         *m_CorrectionVisibleCheck;
   QPushButton       *m_ApplyButton;

   bool m_b_Visible;
   
   int m_i_CurrentMode;
   
   unsigned char m_uca_CorrectionRed[256];
   unsigned char m_uca_CorrectionGreen[256];
   unsigned char m_uca_CorrectionBlue[256];
   unsigned char m_uca_CorrectionLightness[256];
};


#endif // _CORRECTIONBOX_H
