#ifndef _DRAWING_AREA_H
#define _DRAWING_AREA_H

#include <qwidget.h>
#include <qimage.h>
#include <qpainter.h>

#include "PTypes.h"

#include "Callback.h"

#include "GlobalStorage.h"
#include "Tracer.h"

class DrawingArea : public QWidget, public Tracer
{

  Q_OBJECT

public:
   DrawingArea(QWidget *parent,GlobalStorage *pc_GlobalStorage,
               int i_PixelSizeX=0, int i_PixelSizeY=0);

   ~DrawingArea();


   void InstallResizeCallback(Callback c_Callback);
   void InstallExposeCallback(Callback c_Callback);
   void InstallMouseStartCallback(Callback c_Callback);
   void InstallMouseDoCallback(Callback c_Callback);
   void InstallMouseEndCallback(Callback c_Callback);
   void InstallMouseOverCallback(Callback c_Callback);




   int GetWidth();
   int GetHeight();
   int GetOldWidth();
   int GetOldHeight();
   QImage * GetImage();

protected:

   void  resizeEvent(QResizeEvent *theEvent);
   void  paintEvent(QPaintEvent *theEvent);
   void  mousePressEvent(QMouseEvent *theEvent);
   void  mouseMoveEvent(QMouseEvent *theEvent);
   void  mouseReleaseEvent(QMouseEvent *theEvent);

private:
   int m_i_Width;
   int m_i_Height;

   int m_i_OldWidth;
   int m_i_OldHeight;

   QImage *m_CurrentImage;

   Callback m_ResizeCallback;
   Callback m_ExposeCallback;
   Callback m_MouseDoCallback;
   Callback m_MouseStartCallback;
   Callback m_MouseEndCallback;
   Callback m_MouseOverCallback;

   GlobalStorage *m_pc_GlobalStorage;
   
   bool m_b_InMouseEvent;

} ;

#endif // _DRAWING_AREA_H
