#ifndef _FILELOADER_H
#define _FILELOADER_H

#include <qstring.h>
#include <qwidget.h>

#include "PixelBuffer.h"

extern "C"
{
#include <jpeglib.h>
#include <gif_lib.h>
}


class FileLoader
{
public:
   FileLoader(QWidget *MainWidget);
   ~FileLoader();

   // later with options
   QString AskForFilename(bool b_OpenMode,QString qs_DefaultName="");

   PixelBuffer * LoadFile(QString qs_Filename);
   int SaveFile(QString qs_Filename,PixelBuffer *pc_Image);

private:

   int SaveFileTiff(QString qs_Filename,PixelBuffer *pc_Image);
   int SaveFileJpeg(QString qs_Filename,PixelBuffer *pc_Image);
   int SaveFilePng(QString qs_Filename,PixelBuffer *pc_Image);

   PixelBuffer * LoadFileJpeg(QString qs_Filename);
   PixelBuffer * LoadFileGif(QString qs_Filename);
   PixelBuffer * LoadFileTif(QString qs_Filename);
   PixelBuffer * LoadFilePng(QString qs_Filename);
   PixelBuffer * LoadFileBmp(QString qs_Filename);


   int JpegSetFilenameForLoad(QString qs_Filename,
                              int &i_Width,
                              int &i_Height);
   unsigned char *JpegReadLine (  );

   void JpegClose();

   QString GetExtension(QString qs_Name);
   
   void SetGifLine(int i_Line,
                    unsigned char * &Source,
                    PixelBuffer* pc_Destination,
                    GifColorType *Colors);



   QWidget *m_MainWidget;



   // structure for reading a jpeg file
   FILE *m_JpegFile;
   struct jpeg_decompress_struct jpegInfo;
   struct jpeg_error_mgr         jpegError;
   JSAMPARRAY m_JpegOutputLine;

};

#endif // _FILELOADER_H
