#ifndef _FILTER_H
#define _FILTER_H

#include "GlobalStorage.h"
#include "PTypes.h"

class Filter
{
public:
   Filter(GlobalStorage *pc_Global);
   ~Filter();


   void DoFilter();
   enum {
         FilterNothing,
         FilterMedian,
         FilterMiddle
   };

   void SetFilterType(int i_Type);
   void SetFilterWidth(int i_Width);
   
   void SetNearDistance(int i_Distance);
   void SetNearMode(bool b_On);
   
   void SetOnlyOneMode(bool b_On);
   void SetOnlyOneColor(Pixel p_Color);
   void SetOnlyOneColorDistance(int i_Distance);

   void SetOriginalBuffer(PixelBuffer * pc_Image);

private: // functions
   void DoFilterMedian();
   void DoFilterMiddle();

   void CreateCopy();
   void CleanUp();

private: // variables

   PixelBuffer *m_pc_Original;
   PixelBuffer *m_pc_Copy;

   GlobalStorage *m_pc_GlobalStorage;
   // which filter to use
   int m_i_FilterType;

   int m_i_FilterWidth;
   int  m_i_NearDistance;
   bool m_b_NearEnabled;

   bool m_b_CopySelfAllocated;

   // and some more Filter-Options
   bool            m_b_OnlyOneColorActive;
   int             m_i_OnlyOneColorDistance;
   Pixel           m_p_OnlyOneColor;

} ;



#endif  // _FILTER_H

