#ifndef _FILTERBOX_H
#define _FILTERBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qvgroupbox.h>


#include "StandardDialog.h"
#include "QULabelSlider.h"
#include "QUColorDragWidget.h"
#include "Tracer.h"
#include "Filter.h"


class FilterBox :  public StandardDialog ,
                  public Tracer
{
Q_OBJECT

public:
   FilterBox(QWidget *parent=0,
            GlobalStorage *pc_Global=0);

public slots:
   
   void FilterWidthChanged(int i_Width);

   void NearDistanceChanged(int i_Distance);
   void FilterOnlyNearClicked(bool b_On);

   void OnlyOneDistanceChanged(int i_Distance);
   void FilterOnlyOneClicked(bool b_On);
   void OnlyOneColorChanged(Pixel p_NewColor);

   void ActivateMiddle();
   void ActivateMedian();


private:
   void PrepareFiltering(int i_FilterType);
   void EndFiltering();

    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);

   QULabelSlider * m_FilterWidthSlider;
   QPushButton   * m_MiddleButton;
   QPushButton   * m_MedianButton;
   
   QVGroupBox    * m_NearBox;
   QCheckBox     * m_OnlyFilterNearColorsCheck;
   QULabelSlider * m_NearDistanceSlider;

   QVGroupBox    * m_OnlyOneColorBox;
   QCheckBox     * m_OnlyOneColorCheck;
   QULabelSlider * m_OnlyOneColorDistanceSlider;
   QUColorDragLabeledWidget * m_OnlyOneColorButton;


   Filter        * m_pc_Filter;

   int             m_i_FilterWidth;
   int             m_i_NearDistance;
   bool            m_b_NearEnabled;

   bool            m_b_OnlyOneColorActive;
   int             m_i_OnlyOneColorDistance;
   Pixel           m_p_OnlyOneColor;

};


#endif // _FILTERBOX_H
