#ifndef _GRAPHIC_OBJECT_ATTRIBUTE_H
#define _GRAPHIC_OBJECT_ATTRIBUTE_H

#include <qptrlist.h>
#include <qstring.h>

#include "PTypes.h"
#include "Geometry.h"
#include "PixelBuffer.h"


//#########################################################################

class GraphicObjectAttribute
{
public:
   GraphicObjectAttribute();
   ~GraphicObjectAttribute();

   // different type of object attributes
   enum
   {
       Invalid=0,
       Color=1,
       StartPoint,
       EndPoint,
       Image,
       RotationAngle
   };
   int  m_e_ObjectAttributeType;


   Pixel         m_p_Color;
   GeoCoordinate m_c_Coordinate;
   double        m_d_Value;
   PixelBuffer  *m_pc_ImageData;

   // some convinience functions
   static GraphicObjectAttribute *GraphicAttributeStartpoint( GeoCoordinate c_Coordinate);
   static GraphicObjectAttribute *GraphicAttributeEndpoint(GeoCoordinate c_Coordinate);
   static GraphicObjectAttribute *GraphicAttributeColor( Pixel p_Color);
   static GraphicObjectAttribute *GraphicAttributeRotationAngel( double d_Angle);
   static GraphicObjectAttribute *GraphicAttributeImage( PixelBuffer *pc_Image);

   Pixel GetColor();
   void  SetColor(Pixel p_Color );
   double GetRotationAngle();
   void   SetRotationAngle(double d_Angle);
   GeoCoordinate GetStartPoint();
   GeoCoordinate GetEndPoint();

};

//#########################################################################


class GraphicObjectAttributeList
{
public :
	GraphicObjectAttributeList();
	~GraphicObjectAttributeList();

	void AddAttribute(GraphicObjectAttribute *pc_Attribute);

	GraphicObjectAttribute *GetAttribute(int e_AttributeType);

private:
	QPtrList<GraphicObjectAttribute> m_AttributeList;

};

//#########################################################################

#endif // _GRAPHIC_OBJECT_ATTRIBUTE_H

