
#include <stdio.h>

#include "GraphicObjectPoint.h"


GraphicObjectPoint :: GraphicObjectPoint(float f_X, float f_Y)
   				:GraphicObject()
{
   GraphicObjectAttribute * m_StartPoint;

   // store the object type
   m_b_ObjectType = TypePoint;

   m_StartPoint = new GraphicObjectAttribute();

   if( m_StartPoint == NULL)
   {
      return ;
   }

   // create a startpoint
   m_StartPoint->m_e_ObjectAttributeType = GraphicObjectAttribute::StartPoint;

   m_StartPoint->m_c_Coordinate.SetXY(f_X, f_Y);

   m_Attributes.AddAttribute(m_StartPoint);

   // currently no other attributes

} // GraphicObjectPoint()

//===========================================================================
//
//===========================================================================

void GraphicObjectPoint::GetPosition(float &f_X,float &f_Y)
{
   GraphicObjectAttribute * m_StartPoint;
   GeoCoordinate            c_Position;
   
   m_StartPoint = GetAttribute(GraphicObjectAttribute::StartPoint);
   if(m_StartPoint ==NULL)
   {
      f_X=0.0;
      f_Y=0.0;

      return;
   }

   c_Position= m_StartPoint->m_c_Coordinate;
   f_X = c_Position.GetX();
   f_Y = c_Position.GetY();

} // GetPosition()

//===========================================================================
//
//===========================================================================

void GraphicObjectPoint::MoveTo( float f_OriginX, float f_OriginY)
{
   GraphicObjectAttribute * m_StartPoint;
   m_StartPoint = GetAttribute(GraphicObjectAttribute::StartPoint);

   m_StartPoint->m_c_Coordinate.SetXY(f_OriginX,f_OriginY);

   m_b_CachedSizeValid = false;
} // MoveTo

//===========================================================================
//
//===========================================================================

void GraphicObjectPoint::MoveOffset( float f_OffsetX, float f_OffsetY)
{
   GraphicObjectAttribute * m_StartPoint;
   m_StartPoint = GetAttribute(GraphicObjectAttribute::StartPoint);

   m_StartPoint->m_c_Coordinate.Transform(f_OffsetX,f_OffsetY);

   m_b_CachedSizeValid = false;
} // MoveOffset()

//===========================================================================
//
//===========================================================================

RectRegion GraphicObjectPoint::GetSize()
{
   GraphicObjectAttribute * m_StartPoint;
   GeoCoordinate            c_Position;

   if( m_b_CachedSizeValid)
   {
      return m_CachedSize;
   }
   m_CachedSize.SetEmpty();

   m_StartPoint = GetAttribute(GraphicObjectAttribute::StartPoint);
   if(m_StartPoint ==NULL)
   {
      return m_CachedSize;
   }

   c_Position= m_StartPoint->m_c_Coordinate;
   m_CachedSize.SetXYWH(c_Position.GetX()-5.0,
                       c_Position.GetY()-5.0,
                       (float)10.0,
                       10.0);

   m_b_CachedSizeValid = true;
   return m_CachedSize;
} // GetSize()

//===========================================================================
//
//===========================================================================

