#ifndef _GRIDBOX_H
#define _GRIDBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>

#include "PTypes.h"
#include "StandardDialog.h"
#include "QUPixelButton.h"
#include "QUColorDragWidget.h"

class GridBox :  public StandardDialog
{
Q_OBJECT

public:
   GridBox(QWidget *parent=0,
			GlobalStorage *pc_Global=0);

public slots:

   void ApplySettings();
   void DoReset();
   void SelectClicked();
   void VisibleClicked(bool b_On);
   void TextChanged(const QString &qs_Text);
   void GridColorChanged(Pixel c_Color);


private: // functions
    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);

    void SetValuesIntoFields();
    void CheckValues();
    void *SelectionEventArrived(void *pc_Data);

    static void *SelectionEventArrivedCB(void *Thisdata,void *pc_Data);

private: // variables

   QLineEdit   *m_WidthEdit;
   QLineEdit   *m_HeightEdit;
   QLineEdit   *m_OffsetXEdit;
   QLineEdit   *m_OffsetYEdit;

   QPushButton *m_ApplyButton;
   QPushButton *m_ResetButton;
   QPushButton *m_SelectImageButton;
   QCheckBox   *m_VisibleCheck;
   QUColorDragLabeledWidget *m_GridcolorWidget;

   Pixel m_p_GridColor;
   int m_i_Width;
   int m_i_Height;
   int m_i_OffsetX;
   int m_i_OffsetY;
   bool m_b_Visible;

}; // class GridBox


#endif // _GRIDBOX_H
