
#ifndef _ICONLIBRARY_H
#define _ICONLIBRARY_H


#include <stdio.h>
#include <qstring.h>
#include <qpixmap.h>
#include "PixelBuffer.h"


class IconEntry
{
public:
   IconEntry();
   char m_Name[64];
   union
   {
      int m_OffsetPixelData;
      PixelBuffer *m_Buffer;
   };
};



class IconLibrary
{
public:
   IconLibrary(void *pc_IconStructure);
   ~IconLibrary();

   void SaveToCFile(QString cs_FileName);
   void AddIconFromFile(QString qs_Name,QString cs_FileName);
   PixelBuffer *GetIcon(QString cs_IconName);
   QPixmap *GetPixmap(QString cs_IconName);
   QImage  *GetImage(QString cs_IconName);
private:
   int WriteInt(unsigned int i_Value);
   int WriteChar(unsigned char *uc_Memory,int i_Length);
   int WriteHeader();
   int WriteFooter();
   int WriteOne(unsigned char uc_Value);
private:
   void *m_pc_IconStructure;
   bool m_b_ReadFromMemory;
   int  m_i_NumberOfIcons;
   int  m_i_MaximumNumberInArray;
   IconEntry * m_IconDirectory;

   int m_i_CurrentCharPosition;
   bool m_b_FirstNumber;
   FILE *fp_Outfile;
}; // IconLibrary;


#endif // _ICONLIBRARY_H

