#ifndef _MASKBOX_H
#define _MASKBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qvgroupbox.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

#include "StandardDialog.h"
#include "QULabelSlider.h"
#include "QUColorDragWidget.h"
#include "Tracer.h"
#include "Filter.h"


class MaskBox :  public StandardDialog ,
                  public Tracer
{
Q_OBJECT


public:
   MaskBox(QWidget *parent=0,
            GlobalStorage *pc_Global=0);


public slots:
   void SafetyMaskVisibleClicked(bool b_On);
   void SafetyMaskActiveClicked(bool b_On);

   void SafetyMaskColorChanged(Pixel p_Color);

   void SafetyMaskInvert();
   void SafetyMaskClear();
   
   void SelectionMaskVisibleClicked(bool b_On);
   void SelectionMaskActiveClicked(bool b_On);

   void SelectionMaskColorChanged(Pixel p_Color);

   void SelectionMaskInvert();
   void SelectionMaskClear();

   void PaintModeChanged(int i_NewMode);
   void MaskDrawModeChanged(int i_NewMode);

private:


    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);

   void SetSensitivity();

   QCheckBox     * m_SafetyMaskVisible;
   QCheckBox     * m_SafetyMaskActive;
   QPushButton   * m_SafetyInvertButton;
   QPushButton   * m_SafetyClearButton;

   QCheckBox     * m_SelectionMaskVisible;
   QCheckBox     * m_SelectionMaskActive;
   QPushButton   * m_SelectionInvertButton;
   QPushButton   * m_SelectionClearButton;

   QButtonGroup  * m_ModeWidget;
   QRadioButton  * m_ModeInImage;
   QRadioButton  * m_ModeInSafetyMask;
   QRadioButton  * m_ModeInSelectionMask;

   QUColorDragWidget * m_SafetyMaskColorWidget;
   Pixel               m_SafetyMaskColor;
   QUColorDragWidget * m_SelectionMaskColorWidget;
   Pixel               m_SelectionMaskColor;

   QButtonGroup  * m_MaskDrawModeWidget;
   QRadioButton  * m_MaskDrawModeExtend;
   QRadioButton  * m_MaskDrawModeReduce;

   int m_i_PaintMode;
   int m_i_MaskDrawMode;
};


#endif // _MASKBOX_H
