#ifndef _MOUSEEVENT_H
#define _MOUSEEVENT_H

#include <qwidget.h>

#include "DrawingArea.h"
#include "GlobalStorage.h"
#include "Callback.h"



class MouseEvent
{
public:
   MouseEvent(GlobalStorage *pc_GlobalStorage);
   ~MouseEvent();

   enum {
         EventStart,
         EventDo,
         EventEnd,
         EventOver
   };

   void GetLastWindowCoordinates(int &i_X, int &i_Y);
   void GetLastBufferCoordinates(int &i_X, int &i_Y);
   int  GetButtonState();


   // later it might be a list
   void AddEventCallback(Callback EventCallback);
   void RemoveEventCallback(Callback EventCallback);
   int GetEventType( );

private:

   void *EventArrived(QMouseEvent *pc_MouseEvent,int e_Type);
   void DisplayCoordinates(int i_X,int i_Y);


   static void *MouseStartEventCB(void *Thisdata,void *ClientData);
   static void *MouseDoEventCB(void *Thisdata,void *ClientData);
   static void *MouseEndEventCB(void *Thisdata,void *ClientData);
   static void *MouseOverEventCB(void *Thisdata,void *ClientData);

   GlobalStorage *m_pc_GlobalStorage;

   int m_i_LastWindowX;
   int m_i_LastWindowY;
   int m_i_LastBufferX;
   int m_i_LastBufferY;
   int m_i_LastEventType;

   int m_i_LastButtonState;

   Callback m_CurrentEventCallback;


};


#endif // _MOUSEEVENT_H
