/***************************************************************************
                          PTypes.h  -  description
                             -------------------
    begin                : Tue Jul 16 2002
    copyright            : (C) 2002 by 
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef _PTYPES_LOADED_H
#define _PTYPES_LOADED_H


#define BITNUMBER_BIT     1   /* bit  has 1 bit */
#define BITNUMBER_DUO     2   /* duo  has 2 bit */
#define BITNUMBER_NIBBLE  4	  /* nibble  has 4 bit */
#define BITNUMBER_BYTE    8   /* byte has 8 bit */
#define BITNUMBER_WORD    16  /* word has 16 bit */
#define BITNUMBER_TRIPLE  24  /* 3 byte = 24 bit */
#define BITNUMBER_LONG    32  /* long has 32 bit */


// 8 bit type
#define PBYTE unsigned char

// 16 bit type
#define PWORD unsigned short int

// 32 bit type
#define PLONG unsigned int


// universal pixel type
typedef  PLONG Pixel;



// mask for colors
#define PIXEL_RED_MASK   0x00ff0000
#define PIXEL_GREEN_MASK 0x0000ff00
#define PIXEL_BLUE_MASK  0x000000ff


// shifts for colors
#define PIXEL_RED_SHIFT   16
#define PIXEL_GREEN_SHIFT 8
#define PIXEL_BLUE_SHIFT  0

// get only the one color
#define PIXEL_RED(x)   ((x&PIXEL_RED_MASK  )>>PIXEL_RED_SHIFT  )
#define PIXEL_GREEN(x) ((x&PIXEL_GREEN_MASK)>>PIXEL_GREEN_SHIFT)
#define PIXEL_BLUE(x)  ((x&PIXEL_BLUE_MASK )>>PIXEL_BLUE_SHIFT )


// build up one pixel
#define PIXEL_MAKE(r,g,b) ((((Pixel)r) << PIXEL_RED_SHIFT)   | \
                           (((Pixel)g) << PIXEL_GREEN_SHIFT) | \
                           (((Pixel)b) << PIXEL_BLUE_SHIFT)   )




typedef void *(*CallbackFunction)(void *, void *);

#endif
