#ifndef _PIXELBUFFEROBJECT_H
#define _PIXELBUFFEROBJECT_H

// connection between graphic objects and pixel buffers

#include "PixelBuffer.h"
#include "GraphicObjectLayer.h"

class PixelBufferObject
{
public:
   PixelBufferObject();
   ~PixelBufferObject();


   void SetDestinationBuffer(PixelBuffer *pc_Destionation);
   void SetObject(GraphicObject *pc_Object);
   void SetRegion(RectRegion c_DestinationRegion);
   void SetTransparency(bool b_Enabled, int i_Factor);
   void SetMergeBorder(bool b_Enabled, int i_BorderWidth);
   
   RectRegion InsertObject();
   
private:
   PixelBuffer *m_pc_Destination;
   GraphicObject *m_pc_Object;
   RectRegion    m_c_DestinationRegion;
   bool          m_b_UseTransparency;
   int           m_i_TransparencyFactor;
   bool          m_b_MergeAtBorder;
   int           m_i_WergeWidth;
   bool          m_b_MergeWithSmoothBorder;
   int           m_i_MergeBorderWidth;
   

};


#endif // _PIXELBUFFEROBJECT_H

