#ifndef _COLORDRAGWIDGET_H
#define _COLORDRAGWIDGET_H

#include <qwidget.h>
#include <qlabel.h>

#include "PTypes.h"
#include "GlobalStorage.h"
#include "Tracer.h"

class QUColorDragWidget : public QWidget , public Tracer
{
Q_OBJECT
public:

   enum
   {
      ModePipette=1,
      ModeSetSize
   };

   QUColorDragWidget(QWidget *p_Parent,
                     unsigned int ui_Mode=0,
                     GlobalStorage *pc_GlobalStorage=NULL,
                     int i_Width=0,
                     int i_Height=0);

   void SetColor(Pixel c_Color);
   Pixel GetColor();

signals:
   void	ColorChanged(Pixel);
   void	DragStarted(Pixel);

protected:
   void  mousePressEvent(QMouseEvent *theEvent);

private:
   void SaveColorInHistory(Pixel p_Color);

   void StartDrag();
   void StartPipette();

   void *SelectionEventArrived(void *pc_Data);

   static void *SelectionEventArrivedCB(void *Thisdata,void *pc_Data);


   void dragEnterEvent(QDragEnterEvent* event);
   void dropEvent(QDropEvent* event);


   Pixel m_Color;

   unsigned int m_ui_Mode;
   GlobalStorage *m_pc_GlobalStorage;

#define QUCOLORDRAGWIDGET_MAX_HISTORY_COLORS 12
   Pixel m_ColorHistory[QUCOLORDRAGWIDGET_MAX_HISTORY_COLORS];
   int   m_i_ColorsInHistory;

} ;// QUColorDragWidget

class QUColorDragLabeledWidget : public QWidget
{
Q_OBJECT
public:

   QUColorDragLabeledWidget(QWidget *p_Parent,
                     QString qs_Label,
                     unsigned int ui_Mode=0,
                     GlobalStorage *pc_GlobalStorage=NULL);

   void SetColor(Pixel c_Color);
   Pixel GetColor();

signals:
   void	ColorChanged(Pixel);
   void	DragStarted(Pixel);

public slots:
   void PColorChanged(Pixel);
   void PDragStarted(Pixel);


private:
   QUColorDragWidget * m_w_ColorWidget;
   QLabel            * m_w_Label;

} ; // QUColorDragLabeledWidget

#endif // _COLORDRAGWIDGET_H
