#ifndef _QUCOLORORPATTERN_H
#define _QUCOLORORPATTERN_H

#include <qlabel.h>
#include <qslider.h>
#include <qvbox.h>
#include <qcheckbox.h>


#include "GlobalStorage.h"
#include "QUColorDragWidget.h"
#include "QUImageDragLabel.h"

class QUColorOrPattern: public QWidget
{
Q_OBJECT

public:
   QUColorOrPattern(QWidget *parent,
                    GlobalStorage *pc_GlobalStorage);



   ~QUColorOrPattern();

   void SetColor(Pixel p);
   void SetPattern(PixelBuffer *pc_Pattern);
   Pixel GetColor();
   PixelBuffer * GetPattern();

   bool IsColorActive();
   void SetColorActive(bool b_Active);

public slots:
   void PatternToggled(bool b_Mode);
   void ColorToggled(bool b_Mode);

   void InternalColorChanged(Pixel);
   void InternalImageDropped(PixelBuffer *pc_Image);


signals:
   void ColorChanged(Pixel);
   void ImageDropped(PixelBuffer *pc_Image);
   void ModeChange(bool b_PatternMode);

private:

   GlobalStorage *m_pc_GlobalStorage;


   QCheckBox *m_ColorSelected;
   QCheckBox *m_PatternSelected;

   QUColorDragWidget *m_ColorWidget;
   QUImageDragLabel  *m_PatternWidget;

   bool m_b_InUpdate;
   bool m_b_ColorIsSelected;

   Pixel        m_p_CurrentPixel;
   PixelBuffer *m_pc_CurrentPattern;

}; // class UColorOrPattern




#endif // _QUCOLORORPATTERN_H

