#ifndef _QUIMAGEDRAGLABEL_H
#define _QUIMAGEDRAGLABEL_H

#include <qwidget.h>
#include <qlabel.h>
#include <qpixmap.h>

#include "PTypes.h"
#include "GlobalStorage.h"
#include "Tracer.h"
#include "PixelBuffer.h"

class QUImageDragLabel : public QLabel , public Tracer
{
Q_OBJECT
public:

   enum
   {
      ModeUseWidthHeight = 1 ,
      ModeEnablePopup
   };

   QUImageDragLabel(QWidget *p_Parent,
                     unsigned int ui_Mode=0,
                     GlobalStorage *pc_GlobalStorage=NULL,
                     int i_Width=0,
                     int i_Height=0
                     );
   ~QUImageDragLabel();

   void SetImage(QImage *pc_Image);
   void SetPixelBuffer(PixelBuffer *pc_PixelBuffer);

signals:
   void ImageDropped(PixelBuffer *pc_Image);
   
protected:
   void  mousePressEvent(QMouseEvent *theEvent);

private:
   void dragEnterEvent(QDragEnterEvent* event);
   void dragMoveEvent(QDragMoveEvent* event);
   void dropEvent(QDropEvent* event);
   void StartDrag();

   void *SelectionEventArrived(void *pc_Data);
   static void *SelectionEventArrivedCB(void *Thisdata,void *pc_Data);
   void CutRectangleImage();
   void CutFreeHandImage();



//   Pixel m_Color;

   int m_i_Width;
   int m_i_Height;
   unsigned int m_ui_Mode;
   GlobalStorage *m_pc_GlobalStorage;

   QPixmap *m_Pixmap;
   QPixmap *m_UnusedPixmap;

   void *m_p_DragData;
   bool  m_b_DragPossible;

   enum
   {
      DragSelectionNone,
      DragSelectionRectangle,
      DragSelectionFreehand
   };
   int m_i_SelectionMode;
   


} ;// QQUImageDragLabel


#endif // _QUIMAGEDRAGLABEL_H
