#ifndef _LABELSLIDER_H
#define _LABELSLIDER_H

#include <qlabel.h>
#include <qslider.h>
#include <qvbox.h>


class QULabelSlider: public QWidget
{
Q_OBJECT

public:
   QULabelSlider(QWidget *parent,
                 bool b_AutomaticLabel=true, 
                 int i_From=1,
                 int i_To=10,
                 int i_Value=1,
                 QString qs_Description="",
                 int i_DescriptionChars=0
                 );
   ~QULabelSlider();

   void SetValue(int i_Value,QString qs_Label="");
   void SetLabel(QString qs_Label);

   int GetValue();
   void SetLabelStringSize(int i_Letters);

public slots:
   void DoSliderValueChanged(int);

signals:
   void	valueChanged(int);


private:
   
   QLabel      *m_SliderDescription;

   QSlider     *m_Slider;
   QLabel      *m_SliderLabel;
   
   int     m_i_DescriptionChars;
   int     m_i_CurrentValue;
   QString m_qs_CurrentLabel;
   bool    m_b_AutomaticLabel;

   bool    m_b_DisableUpdate;

}; // class QULabelSlider




#endif // _LABELSLIDER_H

