

#include "QUPixelButton.h"

#include <qhgroupbox.h>
#include <qlayout.h>

#include "QtUtilities.h"
#include "ApplicationStorage.h"
#include "IconLibrary.h"
#include "PixelBuffer.h"
#include "qtooltip.h"

//===========================================================================
//
//===========================================================================

QUPixelButton::QUPixelButton(QWidget *parent,
                 QString qs_IconName,
                 QString qs_DefaultText) :
                 QPushButton(parent)
{
   QPixmap *pc_Icon;
   int i_Width;
   int i_Height;

   // get icon from the library
   pc_Icon = g_Application->m_pc_IconLibrary->GetPixmap(qs_IconName);

   if(pc_Icon == NULL)
   {
      // failed to load icon
      fprintf(stderr,"Failed to load icon %s\n",(const char *) qs_IconName);

      setText(qs_DefaultText);
      return;
   }

   i_Width  = pc_Icon->width();
   i_Height = pc_Icon->height();
   // attach the pixmap into the icon
   setPixmap(*pc_Icon);

   // icon is not needed any longer
   delete pc_Icon;
   setMaximumWidth  (i_Width +4);
   setMaximumHeight (i_Height+4);
   
   // add the tool tip
   QToolTip::add(this,qs_DefaultText);
} // QUPixelButton() - contructor

