#ifndef _REDEYEBOX_H
#define _REDEYEBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qhgroupbox.h>


#include "StandardDialog.h"
#include "Tracer.h"

#include "GraphicObjectLayer.h"
#include "GraphicObjectMain.h"
#include "QULabelSlider.h"

class RedEyeBox :  public StandardDialog ,
                  public Tracer
{
Q_OBJECT

public:
   RedEyeBox(QWidget *parent=0,
            GlobalStorage *pc_Global=0);

   void DoActivate();
            
public slots:
   void ActiveModeToggled(bool b_Mode);
   void AddButtonPressed();
   void DeleteButtonPressed();
   void DeleteAllButtonPressed();
   void ReduceButtonPressed();

   void DarkeningSliderMoved(int i_NewValue);   

private:  // functions

   void SetSensitivity();

    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);

   void GraphicObjectCallback(GraphicObjectMainEvent *pc_CallbackData);
   static void *GraphicObjectCallbackCB(void *thisData,void *GraphicObjectCallbackData);

   void *SelectionEventArrived(void *pc_Data);
   static void *SelectionEventArrivedCB(void *Thisdata,void *pc_Data);

   
private:  // variables

   bool m_b_ObjectModeActive;
   GraphicObjectLayer     *m_pc_ObjectLayer;

   QCheckBox  *m_ActivateCheck;

   QPushButton  *m_AddButton;
   QPushButton  *m_DeleteButton;
   QPushButton  *m_DeleteAllButton;
   QPushButton  *m_ReduceButton;
   QHGroupBox   *m_RegionBox;
   QULabelSlider *m_DarkeningSlider;

   int m_i_DarkeningValue;
   bool m_b_InRedraw;
   
                                                                                                                                    
};


#endif // _REDEYEBOX_H
