#ifndef _REDEYEREDUCTION_LOADED_H
#define _REDEYEREDUCTION_LOADED_H

#include "PTypes.h"
#include "RectRegion.h"
#include "PixelBuffer.h"
#include "BufferPainter.h"
#include "GraphicObjectLayer.h"
#include "RectRegion.h"


class RedEyeReduction
{
public:
   RedEyeReduction();
   ~RedEyeReduction();

   void SetLayer(GraphicObjectLayer *pc_Layer);
   void SetImage(PixelBuffer *pc_Image);
   void SetDarkeningFactor(int i_Factor);

   void Reduce(RectRegion &c_ChangedRegion);



private:
   PixelBuffer * m_pc_WorkImage;
   PixelBuffer * m_pc_SelectionMask;
   GraphicObjectLayer *m_pc_Layer;
   int m_i_DarkeningFactor;

   bool CheckPoint(int i_X, int i_Y);

} ; // RedEyeReduction



#endif //  _REDEYEREDUCTION_LOADED_H
