

#include "StandardDialog.h"
#include "QtUtilities.h"
#include <qmainwindow.h>
#include <qapplication.h>

StandardDialog::StandardDialog( QWidget *parent,
                GlobalStorage *pc_Global)
   		: QDialog(parent,"StandardDialog",false)

{

   QBoxLayout   *l_DialogButtons;


   m_pc_GlobalStorage = pc_Global;
   // create the box
   m_l_TopLayout = new QVBoxLayout( this,1);

   m_w_TopWidget = new QWidget(this);
   m_l_TopLayout->addWidget(m_w_TopWidget);


   // --- the close button
   l_DialogButtons = new QHBoxLayout( m_l_TopLayout,5);

   m_w_CloseButton = new QPushButton( "Close", this );
   connect( m_w_CloseButton, 
            SIGNAL(clicked()), 
            SLOT( ClosePressed()) );

   l_DialogButtons->addWidget(new QtUtilSpacer(true,false,this) );
   l_DialogButtons->addWidget(m_w_CloseButton);

} // StandardDialog()


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

void StandardDialog::ClosePressed()
{

   this->hide();
} // ClosePressed()

//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

void StandardDialog::OnMessageReceiveCB(void *p_ThisData,
				 QString qs_MessageType,
                                 void *p_Data)
{
   StandardDialog *p_This;

   p_This =(StandardDialog *) p_ThisData;
   p_This->OnMessageReceive(qs_MessageType,p_Data);
}

void StandardDialog::OnMessageReceive(QString qs_MessageType,
                                 void *p_Data)
{
   // virtual function, will get overloaded
} // OnMessageReceive()

//===========================================================================
//
//===========================================================================

void StandardDialog::ResizeDisplay()
{


   resize(QSize(1,1));

   m_pc_GlobalStorage->mainApplication->flushX();
   // for QT2 I have also to use this call
   m_pc_GlobalStorage->mainApplication->sendPostedEvents();
   //   m_pc_Global->mainApplication->processEvents();

   resize(QSize(1,1));


} // ResizeDisplay()

//===========================================================================
//
//===========================================================================

