
#include <qsizepolicy.h>
#include <qhgroupbox.h>
#include <qlayout.h>

#include "StatusBar.h"
#include "ApplicationStorage.h"


//===========================================================================
//
//===========================================================================

StatusBar::StatusBar(QWidget *p_Parent)
          : QStatusBar(p_Parent)
{
   QHBoxLayout  *SliderLayout;
   int           i_WidgetHeight;

   m_Container = new QWidget(this);

   SliderLayout  = new  QHBoxLayout( m_Container,2);

   m_CoordinateEdit = new QtUtilReadOnlyLineEdit(m_Container);
   m_CoordinateEdit->setMinimumWidth(
                         g_Application->m_pc_QtUtility->GetMaximalFontWidth() *8 );
   m_CoordinateEdit->setMaximumWidth(
                         g_Application->m_pc_QtUtility->GetMaximalFontWidth() *8 );

   m_OperationEdit  = new QtUtilReadOnlyLineEdit(m_Container);

   SliderLayout->addWidget(m_CoordinateEdit);
   SliderLayout->addWidget(m_OperationEdit);

   i_WidgetHeight =m_OperationEdit->height();

   setMinimumHeight(i_WidgetHeight);

} // StatusBar() -constructor
//===========================================================================
//
//===========================================================================

void StatusBar::SetCoordinate(int i_X, int i_Y)
{
   QString qs_Text;

   m_i_X = i_X;
   m_i_Y = i_Y;

   qs_Text.sprintf("X:%4d  Y:%4d",m_i_X, m_i_Y);
   m_CoordinateEdit->setText(qs_Text);

} // SetCoordinate()

//===========================================================================
//
//===========================================================================

void StatusBar::SetOperationMode(QString qs_Operation)
{
   m_qs_Operation = qs_Operation;
   
   m_OperationEdit->setText(m_qs_Operation);

} // SetOperationMode()

//===========================================================================
//
//===========================================================================

void StatusBar::resizeEvent ( QResizeEvent * )
{
   // fprintf(stderr,"STATUSBAR RESIZE %d %d\n",width(),height());
   m_Container->setMinimumWidth(width());
   m_Container->setMaximumWidth(width());
} // resizeEvent()

//===========================================================================
//
//===========================================================================

