#ifndef _TRACER
#define _TRACER

#include <qstring.h>

class TracerEntry
{
public:
   TracerEntry();
   ~TracerEntry();
   QString m_qs_Name;
   bool    m_b_TraceEnabled;
   int     m_i_Instances;
   void    * m_p_ListItem;
   static void TraceEnable(QString qs_Name,bool b_State);
};


class Tracer
{
public:
   Tracer(QString qs_Name);
   ~Tracer();



   Tracer  operator<<( char *cp_String);
   Tracer  operator<<( int );
   Tracer  operator<<( double d_Number);
   Tracer  operator<<( bool b_Value);
   bool TraceActive();


   static int GetNumberOfModules();
   static TracerEntry GetEntry(int i_Index);
   static void SetActive(int i_Index, bool b_Active);
   static void SetDataPointer(int i_Index,void *p_Data);

private:
   QString m_qs_Name;
   int     m_i_TracerIndex;

};

#define TRACE ((Tracer &)(*this))

#endif // _TRACER
