#ifndef _UNDO_H
#define _UNDO_H

#include "PixelBuffer.h"


class Undo
{
public:
   Undo();
   ~Undo();
   
   void SaveBufferToUndo(PixelBuffer *pc_Original);

   void DoUndo(PixelBuffer * &pc_BufferToGetRestored,bool &b_SizeChanged);
   void DoRedo(PixelBuffer * &pc_BufferToGetRestored,bool &b_SizeChanged);
   
   void Reset();

   bool IsRedoPossible();
   bool IsUndoPossible();

   
   PixelBuffer * GetActualPicture();
private:
   PixelBuffer *m_pc_ActualPicture;
   PixelBuffer *m_pc_OldPicture;

   bool         m_b_UndoPossible;
   bool         m_b_RedoPossible;

};



#endif // _UNDO_H
