
#include <math.h>

#include "Utilities.h"

//===========================================================================
//
//===========================================================================

void Utilities::swap(int &a, int &b)
{
   int temp;
   temp =a;
   a=b;
   b=temp;
} // swap

//===========================================================================
//
//===========================================================================

void Utilities::swap(float &a, float &b)
{
   float temp;
   temp =a;
   a=b;
   b=temp;
} // swap

//===========================================================================
//
//===========================================================================

float Utilities::Hypothenusis(int i_A, int i_B)
{
   return (float) sqrt((double)( i_A *i_A + i_B*i_B));
} // Hypothenusis()

//===========================================================================
//
//===========================================================================

int Utilities::PixelDistance(Pixel p1, Pixel p2)
{
   int r;
   int g;
   int b;

   r = PIXEL_RED(p1) - PIXEL_RED(p2);
   if(r <0)
   {
      r = - r;
   }

   g = PIXEL_GREEN(p1) - PIXEL_GREEN(p2);
   if(g <0)
   {
      g = - g;
   }

   b = PIXEL_BLUE(p1) - PIXEL_BLUE(p2);
   if(b <0)
   {
      b = - b;
   }

   return r + g + b;
} // PixelDufference

//============================================================================
// simple quicksort on a char array
//============================================================================

void Utilities::QSortBytes(unsigned char *p_Array,
                       int i_Left, int i_Right)
{
   unsigned char uc_Element;
   unsigned char uc_Temp;
   int           i;
   int           j;

   i = i_Left;
   j = i_Right;

   uc_Element = p_Array[ (i_Left + i_Right) / 2];

   do
   {
      while (p_Array[i]  > uc_Element)
      {
         i++;
      }

      while (uc_Element > p_Array[j] )
      {
         j--;
      }

      if (i <= j)
      {

         uc_Temp    = p_Array[i];
         p_Array[i] = p_Array[j];
         p_Array[j] = uc_Temp;
         i++;
         j--;
      }

   }
   while (i <= j);

   if (i_Left < j)
   {
      QSortBytes (p_Array, i_Left, j);
   }
   if (i < i_Right)
   {
      QSortBytes (p_Array, i, i_Right);
   }

} // QSortBytes()

//===========================================================================
//
//===========================================================================
