#ifndef _ZOOMBOX_H
#define _ZOOMBOX_H

#include <qdialog.h>

#include <qlineedit.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <qslider.h>
#include <qlabel.h>

#include "GlobalStorage.h"
#include "MessageServer.h"
#include "StandardDialog.h"

class ZoomBox :  public StandardDialog 
{
Q_OBJECT

public:
   ZoomBox(QWidget *parent=0,
           GlobalStorage *pc_Global=0);
   void ZoomInOneStep();
   void ZoomOutOneStep();

public slots:
   void DoSliderValueChanged(int);
   void EntireImagePressed();
   void SelectAreaPressed();

private:
    virtual void OnMessageReceive(QString qs_MessageType,
                                 void *p_Data);
    
    void *SelectionEventArrived(void *pc_Data);

    static void *SelectionEventArrivedCB(void *Thisdata,void *pc_Data);

   int CalculateMaximumZoomFactor(int i_Image,int i_DrawingArea);
   

   QSlider     *m_ZoomSlider;
   QLabel      *m_ZoomSliderLabel;
   QButton     *m_EntireImageButton;
   QButton     *m_SelectAreaButton;

   int m_i_CurrentSlider;
   int m_i_CurrentZoomFactor;
   bool m_b_PreventUpdate;
   
   int m_i_MaxPlusZoom;
   int m_i_MaxMinusZoom;
};


#endif // _ZOOMBOX_H
