// This sourcefile is created by Peter Jodda / peter@jodda.de
// It is under the Peter Jodda license:
// Everyboy may use it on his own risk. This header must stay in the file!
// If you expand this file, please contact me, that I can integrate the
// enhancemants in the original file.
//
// main-modules for khdrecord



#include <qapplication.h>
#include <qcursor.h>

#include <qvbox.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qframe.h>
#include <qgrid.h>
#include <qpopupmenu.h>
#include <qmenubar.h>
#include <qbitmap.h>

#include <qmotifstyle.h>
#include <qwindowsstyle.h>
#include <qplatinumstyle.h>


#include <stdio.h>
#include <stdlib.h>

#include "PTypes.h"
#include "QtUtilities.h"
#include "MainFrame.h"
#include "ApplicationFrame.h"

#include "IconLibrary.h"
#include "PixelBuffer.h"


//===========================================================================
//
//===========================================================================

QtUtility *g_p_QtUtilityObject;

int main(int argc, char *argv[])
{
   QApplication           *pc_Application;
   MainFrame              *pc_Image;
   ApplicationFrame       *pc_ApplicationFrame;

   // then create a GUI application
   pc_Application = new QApplication(argc,argv);

   pc_ApplicationFrame = new ApplicationFrame(pc_Application);

   if(argc<=1)
   {
      // open blank Image
      // create recording main class
      pc_Image = new MainFrame(0,
                               pc_Application,
                               pc_ApplicationFrame);
      pc_ApplicationFrame ->AddMainFrame(pc_Image);
      // show the window
      pc_Image->show();
   }
   else // arguments there
   {
      int i;
      for(i=1; i<argc;i++)
      {
         // create recording main class
         pc_Image = new MainFrame(0,
                                  pc_Application,
                                  pc_ApplicationFrame);
         pc_ApplicationFrame ->AddMainFrame(pc_Image);


         // load an image
         pc_Image->LoadImage(argv[i]);

         // show the window
         pc_Image->show();
      } // for all arguments
   }

   // execte main window
   return pc_Application->exec();

} // main()









